using System;
using System.Runtime.InteropServices;

public class call
{

        [StructLayout(LayoutKind.Explicit)]
        public struct CallbackDelegateIncapsulator
        {
                [FieldOffset(0)]
                CallbackDelegate callback;
                public CallbackDelegateIncapsulator(CallbackDelegate callback) { this.callback = callback; }
        }

	public delegate void CallbackDelegate ();

	[DllImport("libcall.so")]
	extern public static void EmitCallback(ref CallbackDelegateIncapsulator callback);

	[DllImport("libcall.so")]
	extern public static void CallbackProc();


	public static void Main(string[] args)
	{
		CallbackDelegate call = new CallbackDelegate(CallbackProc);
		CallbackDelegateIncapsulator cbi = new CallbackDelegateIncapsulator(call);
		Console.WriteLine("First time");
		EmitCallback(ref cbi);
		Console.WriteLine("Second time");
		EmitCallback(ref cbi);
	}
}

